# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define reltag .PREVIEW1
%global namedversion %{version}%{?reltag}

%define section free

Name:           jboss-webbeans
Version:        1.0.0
Release:        0.2%{?reltag}%{?dist}
Epoch:          0
Summary:        Web Beans
License:        LGPLv2+
URL:            http://www.seamframework.org/WebBeans
Group:          Development/Libraries/Java
# svn export http://anonsvn.jboss.org/repos/webbeans/ri/tags/1.0.0.PREVIEW1/ webbeans-ri-1.0.0.PREVIEW1 && tar cjf webbeans-ri-1.0.0.PREVIEW1.tar.bz2 webbeans-1.0.0.PREVIEW1
# Exported revision 3863.
Source0:        webbeans-ri-1.0.0.PREVIEW1.tar.bz2
Source1:        jboss-webbeans-settings.xml
Source2:        jboss-webbeans-jpp-depmap.xml
Patch0:         jboss-webbeans-build.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       dom4j >= 0:1.6.1
Requires:       javassist >= 0:3.8.1
BuildRequires:  annotation_1_0_api
BuildRequires:  dom4j >= 0:1.6.1
BuildRequires:  el_1_0_api
BuildRequires:  javassist >= 0:3.8.1
BuildRequires:  jboss-ejb-3.1-api >= 0:3.1.0
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-parent
BuildRequires:  jms_1_1_api
BuildRequires:  jpa_3_0_api
BuildRequires:  jsf_1_2_api
BuildRequires:  jta_1_1_api
BuildRequires:  log4j
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  maven-plugin-bundle >= 0:2.0.0
BuildRequires:  maven2-default-skin
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  mojo-maven2-plugin-cobertura
BuildRequires:  servlet_2_5_api
BuildRequires:  testng
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Web Beans.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n webbeans-ri-%{namedversion}
%patch0 -p1 -b .sav0

%{__cp} -p %{SOURCE1} maven2-settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

%{__mkdir} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
export MAVEN_OPTS="-Djava.awt.headless=true"
%{_bindir}/mvn-jpp \
        -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.test.skip=false \
        deploy javadoc:aggregate site

%install
%{__rm} -rf %{buildroot}

pushd maven2-brew

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/jsr299-api/%{namedversion}/jsr299-api-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/jsr299-api/%{namedversion}/jsr299-api-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-api/%{namedversion}/webbeans-api-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-api/%{namedversion}/webbeans-api-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-core/%{namedversion}/webbeans-core-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-core/%{namedversion}/webbeans-core-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-logging/%{namedversion}/webbeans-logging-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-logging/%{namedversion}/webbeans-logging-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-osgi-bundle/%{namedversion}/webbeans-osgi-bundle-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-osgi-bundle/%{namedversion}/webbeans-osgi-bundle-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-spi/%{namedversion}/webbeans-spi-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/jboss/webbeans/webbeans-spi/%{namedversion}/webbeans-spi-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p org/jboss/webbeans/jsr299-api/%{namedversion}/jsr299-api-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jsr299-api.pom
%{__cp} -p org/jboss/webbeans/webbeans-api/%{namedversion}/webbeans-api-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-webbeans-api.pom
%{__cp} -p org/jboss/webbeans/webbeans-build-aggregator/%{namedversion}/webbeans-build-aggregator-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-webbeans-build-aggregator.pom
%{__cp} -p org/jboss/webbeans/webbeans-core/%{namedversion}/webbeans-core-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-webbeans-core.pom
%{__cp} -p org/jboss/webbeans/webbeans-logging/%{namedversion}/webbeans-logging-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-webbeans-logging.pom
%{__cp} -p org/jboss/webbeans/webbeans-osgi-bundle/%{namedversion}/webbeans-osgi-bundle-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-webbeans-osgi-bundle.pom
%{__cp} -p org/jboss/webbeans/webbeans-parent/%{namedversion}/webbeans-parent-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-webbeans-parent.pom
%{__cp} -p org/jboss/webbeans/webbeans-spi/%{namedversion}/webbeans-spi-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-webbeans-spi.pom
%{__cp} -p org/jboss/webbeans/webbeans-version-matrix/%{namedversion}/webbeans-version-matrix-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-webbeans-version-matrix.pom

popd

# depmaps
%add_to_maven_depmap org.jboss.webbeans jsr299-api %{namedversion} JPP/%{name} jsr299-api
%add_to_maven_depmap org.jboss.webbeans webbeans-api %{namedversion} JPP/%{name} webbeans-api
%add_to_maven_depmap org.jboss.webbeans webbeans-build-aggregator %{namedversion} JPP/%{name} webbeans-build-aggregator
%add_to_maven_depmap org.jboss.webbeans webbeans-core %{namedversion} JPP/%{name} webbeans-core
%add_to_maven_depmap org.jboss.webbeans webbeans-logging %{namedversion} JPP/%{name} webbeans-logging
%add_to_maven_depmap org.jboss.webbeans webbeans-osgi-bundle %{namedversion} JPP/%{name} webbeans-osgi-bundle
%add_to_maven_depmap org.jboss.webbeans webbeans-parent %{namedversion} JPP/%{name} webbeans-parent
%add_to_maven_depmap org.jboss.webbeans webbeans-spi %{namedversion} JPP/%{name} webbeans-spi
%add_to_maven_depmap org.jboss.webbeans webbeans-version-matrix %{namedversion} JPP/%{name} webbeans-version-matrix

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs
%{__ln_s} %{_javadocdir}/%{name} %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/jsr299-api-%{namedversion}-sources.jar
%{_javadir}*/%{name}/jsr299-api-sources.jar
%{_javadir}*/%{name}/jsr299-api-%{namedversion}.jar
%{_javadir}*/%{name}/jsr299-api.jar
%{_javadir}*/%{name}/webbeans-api-%{namedversion}-sources.jar
%{_javadir}*/%{name}/webbeans-api-sources.jar
%{_javadir}*/%{name}/webbeans-api-%{namedversion}.jar
%{_javadir}*/%{name}/webbeans-api.jar
%{_javadir}*/%{name}/webbeans-core-%{namedversion}-sources.jar
%{_javadir}*/%{name}/webbeans-core-sources.jar
%{_javadir}*/%{name}/webbeans-core-%{namedversion}.jar
%{_javadir}*/%{name}/webbeans-core.jar
%{_javadir}*/%{name}/webbeans-logging-%{namedversion}-sources.jar
%{_javadir}*/%{name}/webbeans-logging-sources.jar
%{_javadir}*/%{name}/webbeans-logging-%{namedversion}.jar
%{_javadir}*/%{name}/webbeans-logging.jar
%{_javadir}*/%{name}/webbeans-osgi-bundle-%{namedversion}-sources.jar
%{_javadir}*/%{name}/webbeans-osgi-bundle-sources.jar
%{_javadir}*/%{name}/webbeans-osgi-bundle-%{namedversion}.jar
%{_javadir}*/%{name}/webbeans-osgi-bundle.jar
%{_javadir}*/%{name}/webbeans-spi-%{namedversion}-sources.jar
%{_javadir}*/%{name}/webbeans-spi-sources.jar
%{_javadir}*/%{name}/webbeans-spi-%{namedversion}.jar
%{_javadir}*/%{name}/webbeans-spi.jar
%{_datadir}/maven2/poms/JPP.%{name}-jsr299-api.pom
%{_datadir}/maven2/poms/JPP.%{name}-webbeans-api.pom
%{_datadir}/maven2/poms/JPP.%{name}-webbeans-build-aggregator.pom
%{_datadir}/maven2/poms/JPP.%{name}-webbeans-core.pom
%{_datadir}/maven2/poms/JPP.%{name}-webbeans-logging.pom
%{_datadir}/maven2/poms/JPP.%{name}-webbeans-osgi-bundle.pom
%{_datadir}/maven2/poms/JPP.%{name}-webbeans-parent.pom
%{_datadir}/maven2/poms/JPP.%{name}-webbeans-spi.pom
%{_datadir}/maven2/poms/JPP.%{name}-webbeans-version-matrix.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{namedversion}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*/
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Sat Feb 12 2011 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.2.PREVIEW1
- spec cleanup

* Sat Feb 12 2011 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.1.PREVIEW1
- release
